<?php
// Authorize (or not) kadr that wants to enter chat
include_once ("../SYSTEM/RANDOM.PHP");
include_once ("../SYSTEM/STRING.PHP");
include_once ("../SYSTEM/DB_FUNCS.PHP");
include_once ("../SYSTEM/USERS.PHP");
include_once ("../SYSTEM/MSGS.PHP");
include_once ("../SYSTEM/CHANNELS.PHP");
include_once ("../SYSTEM/SESSIONS.PHP");
include_once ("../SYSTEM/AWARDS.PHP");
include_once ("../SYSTEM/MISC.PHP");

$QUERY=str_get_params (getenv ("QUERY_STRING"));

function alg_die ($str)
{
 echo $str."<br>";
 echo ('<a href="../MODULES/LOGIN.PHP?'.getenv ("QUERY_STRING").'">...</a>');
 misc_emit_copyright ();
 dbf_die ("");
}

// Connect to DB
dbf_connect () or die (BZ_ERR_DATABASE_CONNECTION);

// Get info from input form
$in_ip=getenv ('REMOTE_ADDR');
$in_nick=trim (str_extract_form_input ($HTTP_POST_VARS['nick']));
$in_pass=trim (str_extract_form_input ($HTTP_POST_VARS['pass']));
$in_update_sec=str_extract_form_input ($HTTP_POST_VARS['update_sec']);
$in_lines_per_page=str_extract_form_input ($HTTP_POST_VARS['lines_per_page']);
$in_color=str_extract_form_input ($HTTP_POST_VARS['color']);
$in_channel_id=str_extract_form_input ($HTTP_POST_VARS['channel_id']);

if ($in_channel_id<=0) alg_die (BZ_ERR_BAD_CHANNEL);

$chan=chan_get_channel ($in_channel_id,TRUE);
if (!$chan)
 alg_die (BZ_ERR_BAD_CHANNEL);
$ch_name=$chan->name;

// Avoid empty login
if (!$in_nick)
{
 list (,$in_nick)=explode (" ",microtime ());
 $in_nick="Unnamed-".$in_nick;
 if (!defined ("AUTH_FOR_LOG_VIEW"))
  alg_die (BZ_ERR_NICK_EMPTY);
}

$mdr=BZ_USS_USER;

// Get author id (%user_reg_id or IP)
$user=usr_find_user ($in_nick,$in_pass);
if ($user)
{
 $in_color=$user->color;
 $in_img_present=$user->img_present;
 $n_author_id="%".$user->uid;
 $stats=usr_get_channel_status ($user->uid,$in_channel_id);
 if ($stats[BZ_USER_MOD]) $mdr=BZ_USS_MOD;
 if ($stats[BZ_USER_SUPERMOD]) $mdr=BZ_USS_SUPERMOD;
}
else
{
 if ($in_pass)
  alg_die (BZ_ERR_LOGIN_PASSWORD);
 $n_author_id=$in_ip;
}

// Attempt to create new session
$session=new TSession;

sess_drop_expired_sessions (); // drop expired sessions
if ($n_author_id{0}=='%')
{
 sess_drop_session_author_id ($in_channel_id,$n_author_id);
}

$session->ip=$in_ip;
$session->nick=$in_nick;
$session->color=$in_color;
$session->img_present=$in_img_present;
$session->channel_id=$in_channel_id;
$session->author_id=$n_author_id;
$session->update_sec=$in_update_sec;
$session->lines_per_page=$in_lines_per_page;
$session->moder=$mdr;

awd_drop_expired_awards ();

switch ($chan->policy)
{
 case (BZ_CP_NOACCESS):
  if (!defined ("AUTH_FOR_LOG_VIEW"))
   alg_die (BZ_ERR_NO_CHANNEL_ENTRY."<hr>");
 break;
 case (BZ_CP_BLACKLIST_NO_GUESTS):
  if ($mdr==BZ_USS_USER)
  {
   if ($n_author_id{0}!="%")
    alg_die (BZ_ERR_CHANNEL_POLICY_UNREG."<hr>");
   if ($stats[BZ_USER_BLACKLISTED])
    alg_die (BZ_ERR_CHANNEL_POLICY_BL."<hr>");
  }
 break;
 case (BZ_CP_WHITELIST):
  if ($mdr==BZ_USS_USER)
  {
   if ($n_author_id{0}!="%")
    alg_die (BZ_ERR_CHANNEL_POLICY_UNREG."<hr>");
   if (!$stats[BZ_USER_WHITELISTED])
    alg_die (BZ_ERR_CHANNEL_POLICY_WL."<hr>");
  }
 break;
}

if (!defined ("AUTH_FOR_LOG_VIEW"))
{
 $awds=awd_get_awards_author_id ($session->author_id,$session->channel_id,-1,getenv ("REMOTE_ADDR"),TRUE);
 $acc_gt=TRUE; // access granted
 $aacc_gt=TRUE; // archive access granted
 $ban=FALSE;
 $wcnt=0;

 if (!misc_test_arr ($awds))
  alg_die (BZ_ERR_DATABASE_QUERY);
 $chan=chan_get_channel ($session->channel_id);
 if (!$chan)
  alg_die (BZ_ERR_DATABASE_QUERY);

 foreach ($awds as $awd)
 {
  switch ($awd->type)
  {
   case (BZ_AWD_WARNING):
    $wcnt++; break;
   case (BZ_AWD_RDONLY):
    $acc_gt=FALSE; break;
   case (BZ_AWD_BAN):
    $acc_gt=FALSE; $aacc_gt=FALSE; $ban=TRUE; break;
  }
  if ($wcnt>=3) $acc_gt=FALSE;
  if (!$acc_gt) break;
 }

 $awdn=array ();
 list ($awdn[BZ_AWD_WARNING],$awdn[BZ_AWD_RDONLY],$awdn[BZ_AWD_BAN])=
 array ("[+]","[R]","[B]");

 if ($session->author_id{0}=='%')
 {
  $ustat=usr_get_channel_status (substr ($session->author_id,1),$session->channel_id);
  if (($ustat[BZ_USER_MOD])||($ustat[BZ_USER_SUPERMOD]))
  {
   $acc_gt=TRUE;
   $aacc_gt=TRUE;
   //echo "Moders can go everywhere!<br>";
  }
 }

 if (!$acc_gt)
 {
  $ltw_ts=0; // latest warning timestamp
  $ltr_ts=0; // latest read-only timestamp
  $wcnt=0;
  $ws_ts=array ();
  echo "<b> </b><br> (  / IP) ''   :<hr>";
  echo '<table border="1">';
  foreach ($awds as $awd)
  {
   echo "<tr>";
   echo "<td>".$awd->author_nick."</td>";
   echo "<td align='center'><b>".$awdn[$awd->type].
    ($awd->channel_id==-1? BZ_STR_OMNI_AWARD : "")."</b></td>";
   echo "<td>".($awd->type!=BZ_AWD_BAN? date ("d.m H:i:s",$awd->expiry) : "&nbsp;")."</td>";
   echo "<td>".$awd->comment."</td>";
   echo "</tr>";
   if (($awd->type==BZ_AWD_WARNING)&&($wcnt<3))
   {
    array_push ($ws_ts,$awd->expiry);
    $wcnt++;
   }
   if (($awd->type==BZ_AWD_RDONLY)&&($awd->expiry>$ltr_ts))
    $ltr_ts=$awd->expiry;
  }
  echo '</table>';
  if (!count ($ws_ts)) array_push ($ws_ts,0);
  $ltw_ts=min ($ws_ts);
  if ($ltr_ts<$ltw_ts) $ltr_ts=$ltw_ts;
  if ($ltw_ts<$ltr_ts) $ltw_ts=$ltr_ts;
  if ($ban) alg_die ("     [B].");
  else
  alg_die ("<hr>   ".date ("d.m H:i:s",max ($ltr_ts,$ltw_ts)));
 }
}

if ($n_author_id{0}) usr_touch_user (substr ($n_author_id,1));

?>