<?php
// Miscelannous utility functions
if (!defined ("MISC"))
{
 define ("MISC","(c)");
 // misc_emit_radio_group ($name,$strings,$values,$defpos)
 // Output radio group into document
 // Pars: name of group, array of strings, array of according numeric values (number of elems
 // in both arrays should match), default checked button (from 0)
 function misc_emit_radio_group ($name,$strings,$values,$defpos)
 {
  $i=0;
  foreach ($strings as $str)
  {
   echo '<input type="radio" name="'.$name.'" value="'.$values[$i].'"'.
   (($defpos==$i)? " checked" : "").
   '>'.$str;
   $i++;
  }
 }

 // misc_test_arr (& $arr)
 // Tests if a given array is an array (empty or not), not a single value
 // Pars: ref to array
 // Returns: TRUE (it is an array)/FALSE (it is not)
 function misc_test_arr (&$arr)
 {
  return (!count ($arr))||($arr);
 }
 
 function misc_emit_color_selector ()
 {
?>
<select name="color" size="1">
<option value="#404040" style="color:#404040"> (25%  )</option>
<option value="#808080" style="color:#808080"> (50%  )</option>
<option value="#C0C0C0" style="color:#C0C0C0"> (75%  )</option>
<option value="#808000" style="color:#808000"> </option>
<option value="#008080" style="color:#008080">  ( 1)</option>
<option value="#4080C0" style="color:#4080C0">  ( 2)</option>
<option value="#800080" style="color:#800080"> ( 1)</option>
<option value="#8040C0" style="color:#8040C0"> ( 2)</option>
<option value="#8000FF" style="color:#8000FF"> </option> 
<option value="#FF0000" style="color:#FF0000"></option>
<option value="#00FF00" style="color:#00FF00">-</option>
<option value="#0000FF" style="color:#0000FF">-</option>
<option value="#FFFF00" style="color:#FFFF00">Ƹ</option>
<option value="#00FFFF" style="color:#00FFFF"></option>
<option value="#FF00FF" style="color:#FF00FF"></option>
<option value="#800000" style="color:#800000">-</option>
<option value="#008000" style="color:#008000"></option>
<option value="#000080" style="color:#000080"></option>
<option value="#00FF80" style="color:#00FF80">-</option>
<option value="#80FF00" style="color:#80FF00">-</option>
<option value="#0080FF" style="color:#0080FF"></option>
<option value="#FF0080" style="color:#FF0080"></option>
<option value="#FF8000" style="color:#FF8000"></option>
<option value="#FF8080" style="color:#FF8080"></option>
<option value="#80FF80" style="color:#80FF80">-</option>
<option value="#8080FF" style="color:#8080FF">-</option>
<option value="#FFFF80" style="color:#FFFF80">-Ƹ (  )</option>
<option value="#FF80FF" style="color:#FF80FF">-</option>
<option value="#80FFFF" style="color:#80FFFF">  (  )</option> 
<option value="#C08040" style="color:#C08040"></option>
<option value="#40C080" style="color:#40C080"> </option> 
<option value="#80C040" style="color:#80C040">-</option> 
</select>

<?php
 }

 // misc_emit_copyright ()
 // Outputs copyright notice into document
 // Pars, returns: none
 function misc_emit_copyright ()
 {
?>
 <table width="100%"><tr><td align="center">
 <hr>
 Chat engine v1.00: (c) <a href="mailto:mikle33@rin.ru">Mikle</a>, 2003
 </td></tr></table>
<?php
 }
 
}