<?php
// Module that performs handling of registration form (edit registration)
include_once ("../SYSTEM/MISC.PHP");
include_once ("../SYSTEM/CONSTS.PHP");
include_once ("../SYSTEM/STRING.PHP");
include_once ("../SYSTEM/DB_FUNCS.PHP");
include_once ("../SYSTEM/USERS.PHP");
include_once ("../SYSTEM/CHANNELS.PHP");

dbf_connect () or die (BZ_ERR_DATABASE_CONNECTION);

function dr_die ($str)
{
 echo $str."<br>";
 echo ('
 <a href="javascript:history.back()">...</a></br>
 <a href="../MODULES/LOGIN.PHP?'.getenv ("QUERY_STRING").'">  ...</a></br>
 ');
 misc_emit_copyright ();
 dbf_die ("");
}

function dr_die1 ($str)
{
 echo $str."<br>";
 echo ('
 <a href="../MODULES/LOGIN.PHP?'.getenv ("QUERY_STRING").'">  ...</a></br>
 ');
 misc_emit_copyright ();
 dbf_die ("");
}

$in_ologin=trim (str_extract_form_input ($HTTP_POST_VARS['onick']));
$in_opass=trim (str_extract_form_input ($HTTP_POST_VARS['opass']));
$user=usr_find_user ($in_ologin,$in_opass);
if (!$user)
{
 dr_die (BZ_ERR_LOGIN_PASSWORD);
}

// Validate fields:
// login
$in_login=trim (str_extract_form_input ($HTTP_POST_VARS['login']));
if (strlen ($in_login)<BZ_MIN_NAMES_LEN)
 dr_die (BZ_ERR_REG_NICK_EMPTY);

if ($in_login!=$in_ologin)
if (usr_find_user_login ($in_login))
 dr_die (BZ_ERR_REG_NICK_BUSY);

// password
$in_pass1=trim (str_extract_form_input ($HTTP_POST_VARS['password1']));
$in_pass2=trim (str_extract_form_input ($HTTP_POST_VARS['password2']));
if ((($in_pass1)||($in_pass2))&&((strlen ($in_pass1)<BZ_MIN_NAMES_LEN)||(strlen ($in_pass2)<BZ_MIN_NAMES_LEN)))
 dr_die (BZ_ERR_REG_PASSWORD_EMPTY);
if ($in_pass1!=$in_pass2)
 dr_die (BZ_ERR_REG_PASSWORD_DIFF);

// color
$in_color=str_extract_form_input ($HTTP_POST_VARS['color']);

// private channel policy
$in_policy=str_extract_form_input ($HTTP_POST_VARS['pchn_policy']);

// private channel name
$in_pchn_name=str_extract_form_input ($HTTP_POST_VARS['pchn_name']);

// rules for private channel
$in_rules=str_multiline_to_html
 (substr (str_extract_form_input ($HTTP_POST_VARS['pchn_rules'],FALSE),0,BZ_MAX_RULES_LEN));

// Remember data for edit
$user->nick=$in_login;
$user->color=$in_color;

// Channel policies manipulation
$ustats=usr_get_channel_status ($user->uid,$user->pchannel_id);
if (!$ustats)
{
 dr_die (BZ_ERR_REG_PARTIAL);
}

if (!$ustats[BZ_USER_MOD])
{
 echo BZ_ERR_NO_CHANNEL_RIGHT."<br>";
}
else
{
 $chid=$user->pchannel_id;

 $chan=new TChannel;
 $chan->c_index=$chid;
 $chan->name=$in_pchn_name;
 $chan->policy=$in_policy;

 // adjust channel
 if (!chan_edit_channel ($chan,$in_rules))
  echo BZ_ERR_PROF_EDIT_CHANNEL."<br>";
 else
  echo BZ_ERR_PROF_EDIT_CHANNEL_OK."<br>";
}

// Harass the avatar picture
if (!$HTTP_POST_VARS['del_avatar'])
{
 if ($HTTP_POST_FILES['avafile']['name'])
 {
  if (!strcasecmp (substr ($HTTP_POST_FILES['avafile']['name'],-4),".gif"))
   $in_img_present=".gif";
  else
  if (!strcasecmp (substr ($HTTP_POST_FILES['avafile']['name'],-4),".jpg"))
   $in_img_present=".jpg";
  else
  if (!strcasecmp (substr ($HTTP_POST_FILES['avafile']['name'],-5),".jpeg"))
   $in_img_present=".jpeg";
  else
  {
   $in_img_present="?";
   echo BZ_ERR_REG_IMG_INCORRECT."<br>";
  }

  if ($in_img_present!="?")
  if ((!$HTTP_POST_FILES['avafile']['size'])||
  (!is_uploaded_file ($HTTP_POST_FILES['avafile']['tmp_name'])))
  {
   $in_img_present="?";
   echo BZ_ERR_REG_IMG_UPLOAD."<br>";
  }

  if ($in_img_present!="?")
  {
   @unlink (BZ_AVATAR_DIR.$user->uid.$user->img_present);
   @unlink (BZ_AVATAR_DIR.$user->uid.$in_img_present);
   if (move_uploaded_file ($HTTP_POST_FILES['avafile']['tmp_name'],
   BZ_AVATAR_DIR.$user->uid.$in_img_present))
   {
    $user->img_present=$in_img_present;
    @chmod (BZ_AVATAR_DIR.$user->uid.$in_img_present,0666);
   }
   else
   {
    $user->img_present="-";
    echo BZ_ERR_REG_IMG_UPLOAD."<br>";
   }
  }
 }
}
else
{
 // unlink picture
 @unlink (BZ_AVATAR_DIR.$user->uid.".*");
 $user->img_present="-";
}

if (!usr_edit_profile ($user))
 echo BZ_ERR_PROF_EDIT_USER."<br>";
else
 echo BZ_ERR_PROF_EDIT_USER_OK."<br>";

if ($in_pass1)
{
 if (!usr_change_password ($user->uid,$in_pass1))
  echo BZ_ERR_PROF_EDIT_PASSWORD."<br>";
 else
  echo BZ_ERR_PROF_EDIT_PASSWORD_OK."<br>";
 dr_die1 ("");
}
else
{
 dr_die ("");
}

?>