<?php
if (!defined ("CONSTS"))
{
 define ("CONSTS","(c)");

 // Error strings/messages
 define ("BZ_ERR_DATABASE_CONNECTION","   ");
 define ("BZ_ERR_DATABASE_QUERY","    ");
 define ("BZ_ERR_NICK_BUSY","   .");
 define ("BZ_ERR_NICK_EMPTY","   !");
 define ("BZ_ERR_BAD_CHANNEL","  ");
 define ("BZ_ERR_BAD_SESSION_KEY","  ");
 define ("BZ_ERR_SESSION_TERMINATED"," !");
 define ("BZ_ERR_INCORRECT_INVOCATION","   /");
 define ("BZ_ERR_GENERIC_RETRY","    ,     .");
 define ("BZ_ERR_NO_CHANNELS"," -!");
 define ("BZ_ERR_LOGIN_PASSWORD","  '/'");
 define ("BZ_ERR_NO_CHANNEL_MOD","       .");
 define ("BZ_ERR_NO_CHANNEL_RIGHT","<b>      </b>");
 define ("BZ_ERR_NO_CHANNEL_ARIGHT","      .");
 define ("BZ_ERR_NO_CHANNEL_FOUND","<b>:         .
  <br>    ,   .</b>");
 define ("BZ_ERR_NO_CHANNEL_ENTRY","  .");
 define ("BZ_ERR_CHANNEL_POLICY_UNREG","        .");
 define ("BZ_ERR_CHANNEL_POLICY_BL","     .");
 define ("BZ_ERR_CHANNEL_POLICY_WL","     ,    .");

 define ("BZ_ERR_REG_NICK_BUSY","  . :(  .");
 define ("BZ_ERR_REG_NICK_EMPTY","  .   !");
 define ("BZ_ERR_REG_PASSWORD_DIFF","     .  .");
 define ("BZ_ERR_REG_PASSWORD_EMPTY","  .   !");
 define ("BZ_ERR_REG_IMG_INCORRECT","  .");
 define ("BZ_ERR_REG_IMG_UPLOAD","   .");
 define ("BZ_ERR_REG_IMG_DELETED"," .");
 define ("BZ_ERR_REG_PARTIAL","    -  !");
 define ("BZ_ERR_REG_CANCEL"," .   .");
 define ("BZ_ERR_REG_NOT_CANCEL",":    !  .");
 define ("BZ_ERR_REG_OK","   .");

 define ("BZ_ERR_PROF_EDIT_CHANNEL",":      !");
 define ("BZ_ERR_PROF_EDIT_USER",":      !");
 define ("BZ_ERR_PROF_EDIT_PASSWORD",":     !");
 define ("BZ_ERR_PROF_EDIT_CHANNEL_OK","    .");
 define ("BZ_ERR_PROF_EDIT_USER_OK","    .");
 define ("BZ_ERR_PROF_EDIT_PASSWORD_OK","   .");

 define ("BZ_ERR_ADM_NONAMED_CHANNEL","    !");
 define ("BZ_ERR_ADM_CHANNEL_ADDED","   :");
 define ("BZ_ERR_ADM_CHANNEL_REMOVED"," .");
 define ("BZ_ERR_ADM_CHANNEL_RENAMED"," .");
 define ("BZ_ERR_ADM_CHANNEL_RERULED","   .");
 define ("BZ_ERR_ADM_CHANNEL_REPOLICED","    .");
 define ("BZ_ERR_ADM_CHANNEL_PRIVATE","     .");
 define ("BZ_ERR_ADM_CHANNEL_CLEARED","   .");

 define ("BZ_ERR_MOD_MSG_ADDED","   .");
 define ("BZ_ERR_MOD_MSG_NOT_ADDED",":     !!!");
 define ("BZ_ERR_MOD_AWD_REMOVED"," ");
 define ("BZ_ERR_MOD_NO_COMMENT","  .    .");
 define ("BZ_ERR_MOD_NOT_SUPERMOD"," ͨ:   ");

 // Channel policy consts
 define ("BZ_CP_NOACCESS",0);
 define ("BZ_CP_BLACKLIST",1);
 define ("BZ_CP_BLACKLIST_NO_GUESTS",2);
 define ("BZ_CP_WHITELIST",3);

 define ("BZ_CP_DESC_NOACCESS","");
 define ("BZ_CP_DESC_BLACKLIST"," ");
 define ("BZ_CP_DESC_BLACKLIST_NO_GUESTS","  . ");
 define ("BZ_CP_DESC_WHITELIST","  ");

 // User states consts
 define ("BZ_USER_BLACKLISTED",0);
 define ("BZ_USER_WHITELISTED",1);
 define ("BZ_USER_MOD",2);
 define ("BZ_USER_SUPERMOD",3);

 // User sessions consts
 define ("BZ_USS_USER",0);
 define ("BZ_USS_MOD",1);
 define ("BZ_USS_SUPERMOD",2);

 // "Awards" consts
 define ("BZ_AWD_WARNING",0);
 define ("BZ_AWD_RDONLY",1);
 define ("BZ_AWD_BAN",2);

 // Time constants
 define ("SESSION_MAX_LENGTH",120); // 120 secs max per session
 //define ("SESSION_MAX_LENGTH",30); // 30 secs max per session

 define ("MESSAGE_MAX_TTL",1209600); // message stays in DB for 2 weeks
 //define ("MESSAGE_MAX_TTL",1800); // message stays in DB for 30 mins
 define ("MESSAGE_MAX_TTL_LOG",7200); // message stays visile in log for 1 hours
 //define ("MESSAGE_MAX_TTL_LOG",120); // message stays visile in log for 2 mins

 define ("ONE_HOUR",3600); // one hour in seconds

 // Misc constants
 //define ("BZ_AVATAR_DIM",32); // 32 pix/avatar side
 define ("BZ_AVATAR_DIM",24); // 24 pix/avatar side

 define ("BZ_AVATAR_DIR","../GFX/AVATARS/"); // directory for storing avatars

 define ("BZ_MAX_WORD_LEN",40); // 40 symbols - maximum len of unbreakable sym sequence
 define ("BZ_MAX_UMESSAGE_LEN",256); // 256 syms max in a chat message (from usual user)
 define ("BZ_MAX_AMESSAGE_LEN",2048); // 2048 symbols - max len for admin messages

 define ("BZ_MAX_RULES_LEN",2048); // 2048 symbols - max len for channel rules
 define ("BZ_MAX_NAMES_LEN",48); // 48 symbols - max len for nicks/channel names
 define ("BZ_MIN_NAMES_LEN",3); // 3 symbols - min len for nicks/passwords

 define ("BZ_STR_TIME","   :"); // string: "time elapsed per session"
 define ("BZ_STR_TRAFFIC","  :"); // string: "incoming traffic"
 define ("BZ_STR_OMNI_AWARD","[A]"); // string: "this award is valid on all channels"

 define ("BZ_SYSTEM_NAME","[]"); // name to post system messages under
 define ("BZ_SYSTEM_MSG_COLOR","#000000"); // color to post system messages in

 $c_open_adm_tags=array
 ("","<i>","<i><b>");
 $c_close_adm_tags=array
 ("","</i>","</b></i>");

 define ("BZ_MSG_USER_LOGIN","  "); // message "user logged in"
 define ("BZ_MSG_USER_LOGOFF"," "); // message "user logged off"
 define ("BZ_MSG_USER_KICKED","       "); // message "user is evicted"
 define ("BZ_MSG_USER_POLICED","       "); // message "user leaves because of policy changed"

 if (strstr (getenv ("HTTP_USER_AGENT"),"Nav")) // Netscape const
  define ("BZ_NETSCAPE",1);
 else
  define ("BZ_NETSCAPE",0);

 if (strstr (getenv ("HTTP_USER_AGENT"),"MSIE")) // MSIE const
  define ("BZ_MSIE",1);
 else
  define ("BZ_MSIE",0);

 //if (!BZ_MSIE) die ("Non-MSIE browsers yet are not supported");
}
?>