<?php

// Funcs to work w/database (implementation for MySQL)

if (!defined ("DB_FUNCS"))
{
 define ("DB_FUNCS","(c)");
 
 @include_once ("../SYSTEM/DB_PARMS.PHP");
 if (!defined ("DB_PARMS"))
 {
  echo "Chat is not yet properly installed.<br>";
  die ('<a href="../_INSTALL/IFORM.PHP">Go to installation procedure...</a>');
 }

 // DB connection ID
 $dbf_id=FALSE;

 // DB query result
 $dbf_qres=FALSE;

 // dbf_connect ()
 // Performs database connection
 // Pars: none
 // Returns: TRUE (success)/FALSE (not success)
 function dbf_connect ()
 {
  global $dbf_host,$dbf_user,$dbf_password,$dbf_id,$dbf_basename;
  $dbf_id=@mysql_connect ($dbf_host,$dbf_user,$dbf_password);
  if (($dbf_id)&&(mysql_select_db ($dbf_basename,$dbf_id)))
   return $dbf_id;
  @mysql_close ($dbf_id);
  $dbf_id=FALSE;
  return FALSE;
 }

 // dbf_disconnect ()
 // Disconnects from database
 // Pars: none
 // Returns: none
 function dbf_disconnect ()
 {
  global $dbf_id;
  @mysql_query ("COMMIT;"); // confirm changes (?)
  @mysql_close ($dbf_id);
  $dbf_id=FALSE;
 }

 // dbf_query ($query)
 // Makes query to database (not Select!)
 // Pars: SQL string
 // Returns: TRUE (success)/FALSE (query not accepted/no recs handled)
 function dbf_query ($query)
 {
  global $dbf_id;
  dbf_free_result (); // dbf_free_result function defined below
  $dbf_qres=@mysql_query ($query);
  return $dbf_qres;
 }

 // dbf_select_query ($query)
 // Makes query to database (assumed a SELECT one)
 // Pars: SQL string (assumed to be a SELECT query)
 // Returns: int>=0 (num of rows)/-1 (query not accepted)
 function dbf_select_query ($query)
 {
  global $dbf_id,$dbf_qres;
  dbf_free_result (); // dbf_free_result function defined below
  $dbf_qres=@mysql_query ($query);
  if (!$dbf_qres) return -1;
  return @mysql_num_rows ($dbf_qres);
 }

 // dbf_fetch_row ()
 // Gets next row of last query result
 // Pars: none
 // Returns: FALSE (no rows)/ARRAY (associative)
 function dbf_fetch_row ()
 {
  global $dbf_qres;
  return @mysql_fetch_array ($dbf_qres,MYSQL_BOTH);
 }

 // dbf_free_result ()
 // Releases result of previous query
 // Pars: none
 // Returns: none
 function dbf_free_result ()
 {
  global $dbf_qres;
  if ($dbf_qres)
   @mysql_free_result ($dbf_qres);
  $dbf_qres=FALSE;
 }
 
 // dbf_die ($str)
 // Like "die", but performs a disconnection from DB first
 function dbf_die ($str)
 {
  dbf_disconnect ();
  die ($str);
 }
}
?>